<template>
  <div class="sa-date-inputs">
    <div class="heading">
      <label class="label">{{ label }}</label>
      <button
        v-if="selectedDate"
        class="clear-date"
        data-testid="clear"
        @click="clearDate"
      >
        Clear
      </button>
    </div>
    <sa-input-date
      :key="version"
      :size="size"
      :initial-value="initialDate"
      @change="dateChanged"
    />
  </div>
</template>

<script>
export default {
  name: 'SaSelectDateRangeInput',
  props: {
    label: {
      type: String,
      default: ''
    },
    size: {
      type: String,
      default: 'regular'
    },
    initialDate: {
      type: String,
      default: null
    }
  },
  data(props) {
    return {
      version: 1,
      selectedDate: props.initialDate
    }
  },
  methods: {
    dateChanged(value) {
      this.selectedDate = value
      this.$emit('change', value)
    },
    clearDate() {
      // splat the inputs by invalidating their keys, to clear their values
      this.version++
      this.dateChanged(null)
    }
  }
}
</script>

<style lang="scss" scoped>
.sa-date-inputs {
  .heading {
    display: flex;
    justify-content: space-between;
  }
  .clear-date {
    font-size: font-size(0);
    text-decoration: underline;
    color: color(primary);
    &:hover,
    &:focus {
      text-decoration: none;
      color: color(grey);
    }
  }
}
</style>
